%define nb_             netbeans
%define nb_ver          6.1
%define nb_release_time 200805300101
%define nb_home         %{_datadir}/%{nb_}
%define nb_dir          %{nb_home}/%{nb_ver}

%define nb_platform_ver 8
%define nb_platform     platform%{nb_platform_ver}
%define nb_platform_dir %{nb_home}/%{nb_platform}

%define nb_harness      harness
%define nb_harness_dir  %{nb_home}/%{nb_harness}

%define nb_javadoc      javadoc
%define nb_javadoc_dir  %{_javadocdir}/%{nb_}-%{nb_platform}

%define compiler_opt    -Dbuild.compiler.deprecation=false -Dbuild.compiler.debug=false
%define jdk_opt         -Dpermit.jdk6.builds=true
%define verify_opt      -Dverify.checkout=false
%define ant_nb_opt      %{ant} %{jdk_opt} %{compiler_opt} %{verify_opt}

%define nb_javadoc_site http://bits.netbeans.org/%{nb_ver}/javadoc

# Prevents use of autoupdate on the specified directory.
# %1 the directory being prevented for autoupdate.
%define noautoupdate()    echo > %1/.noautoupdate

# Remove artifacts created by the noautoupdate macro.
# %1 the directory has been prevented for autoupdate.
%define rm_noautoupdate() %{__rm} -rf %1/.noautoupdate

Name:         %{nb_}-%{nb_platform}
Version:      %{nb_ver}
Release:      5%{?dist}
Summary:      NetBeans Platform %{nb_platform_ver}
Group:        Development/Libraries
License:      GPLv2 with exceptions or CDDL
URL:          http://platform.netbeans.org
Distribution: %{nb_}-%{nb_ver}

Source0: http://download.netbeans.org/%{nb_}/%{nb_ver}/final/zip/%{nb_}-%{nb_ver}-%{nb_release_time}-platform-src.zip

Patch0: %{name}-%{version}-build_bootstrap.patch
Patch1: %{name}-%{version}-properties.patch
# http://www.netbeans.org/issues/show_bug.cgi?id=134544
Patch2: %{name}-%{version}-win_launcher.patch
# http://www.netbeans.org/issues/show_bug.cgi?id=143729
Patch3: %{name}-%{version}-issue_143729.patch

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildArch: noarch

BuildRequires: jpackage-utils
BuildRequires: java-devel >= 1:1.6.0
BuildRequires: ant >= 1.7.0
BuildRequires: ant-junit >= 1.7.0
BuildRequires: ant-nodeps >= 1.7.0
BuildRequires: ant-trax >= 1.7.0
BuildRequires: junit >= 3.8.2
BuildRequires: swing-layout >= 0:1.0
BuildRequires: javahelp2 >= 2.0.05
BuildRequires: jna >= 3.0.2

Requires: jpackage-utils
Requires: java >= 1:1.6.0
Requires: swing-layout >= 1.0
Requires: javahelp2 >= 2.0.05
Requires: jna >= 3.0.2

Provides: libnb-%{nb_platform} = %{version}

%description
NetBeans Platform is a framework for development of 
Rich Client Swing Applications. It contains powerful
module system and a set of modules providing various
functionalities needed for simplification of 
development of modular desktop applications.

%package %{nb_javadoc}
Summary: Javadoc documentation for NetBeans Platform %{nb_platform_ver}
Group: Documentation
%description %{nb_javadoc}
NetBeans Platform is a set of modules, each providing
their own APIs and working together or in a standalone
mode. This package provides one master 
javadoc to all of them.

%package %{nb_harness}
Summary: Build harness for NetBeans Platform %{nb_platform_ver}
Group: Development/Libraries
Requires: jpackage-utils
Requires: java >= 1:1.6.0
Requires: ant >= 1.7.0
Requires: %{name} = %{version}-%{release}
Requires: javahelp2 >= 2.0.05
Provides: libnb-%{nb_platform}-devel = %{version}
%description %{nb_harness}
Harness with build scripts and ant tasks for everyone who
build an application on top of NetBeans Platform

%prep
%setup -q -c 

find . -type d | xargs -t chmod 755
find . -type f -exec chmod 644 {} ";"
find . -type f \( -iname "*.jar" -o -iname "*.zip" \) | xargs -t %{__rm} -f
find . -type f \( -iname "*.exe" \) | xargs -t %{__rm} -f

# As of Java 6, JSR 223 is included in the JRE.
# Generate the stub jar file, so there is something in jsr223 API module
%{__mkdir_p} libs.jsr223/src/javax/script
echo "package javax.script; class empty { }" > libs.jsr223/src/javax/script/empty.java
%{__mkdir_p} libs.jsr223/external
jar cf libs.jsr223/external/jsr223-api.jar libs.jsr223/src/javax/script/empty.java

# to build the netbeans modules the installed jars will be used instead of pre-packaged ones
%{__ln_s} -f %{_javadir}/swing-layout.jar o.jdesktop.layout/external/swing-layout-1.0.3.jar
%{__ln_s} -f %{_javadir}/javahelp2.jar apisupport.harness/external/jsearch-2.0_05.jar
%{__ln_s} -f %{_javadir}/javahelp2.jar javahelp/external/jh-2.0_05.jar
%{__ln_s} -f %{_javadir}/jna.jar libs.jna/external/jna-3.0.2.jar

%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1

%build

# build platform
%{ant_nb_opt} -f nbbuild/build.xml build-platform
%{__ln_s} -f %{_javadir}/swing-layout.jar nbbuild/netbeans/%{nb_platform}/modules/ext/swing-layout-1.0.3.jar
%{__ln_s} -f %{_javadir}/javahelp2.jar nbbuild/netbeans/%{nb_platform}/modules/ext/jsearch-2.0_05.jar
%{__ln_s} -f %{_javadir}/javahelp2.jar nbbuild/netbeans/%{nb_platform}/modules/ext/jh-2.0_05.jar
%{__ln_s} -f %{_javadir}/jna.jar nbbuild/netbeans/%{nb_platform}/modules/ext/jna-3.0.2.jar

# build platform harness
%{ant_nb_opt} -f apisupport.harness/build.xml
%{__ln_s} -f %{_javadir}/javahelp2.jar nbbuild/netbeans/%{nb_harness}/jsearch-2.0_05.jar

# build platform javadoc
%{ant_nb_opt} \
   -Dallmodules= \
   -Dcluster.config=platform \
   -Dconfig.javadoc.cluster=platform8 \
   -Dconfig.javadoc.netbeans=\
openide.util,openide.actions,openide.options,openide.awt,\
openide.dialogs,openide.nodes,openide.explorer,openide.filesystems,openide.modules,\
openide.text,openide.windows,openide.loaders,openide.io,queries,\
o.n.api.progress,settings,javahelp,openide.execution,\
sendopts,options.api,editor.mimelookup \
   -Djavadoc.docs.org-netbeans-api-java=%{nb_javadoc_site}/org-netbeans-api-java/ \
   -Djavadoc.docs.org-netbeans-modules-project-ant=%{nb_javadoc_site}/org-netbeans-modules-project-ant/ \
   -Djavadoc.docs.org-netbeans-modules-projectapi=%{nb_javadoc_site}/org-netbeans-modules-projectapi/ \
   -f nbbuild/build.xml build-javadoc
%{__rm} -rf nbbuild/build/javadoc/*.zip

# clean up links to ext jars
%{__rm} -f nbbuild/netbeans/%{nb_platform}/modules/ext/swing-layout-1.0.3.jar
%{__rm} -f nbbuild/netbeans/%{nb_platform}/modules/ext/jsearch-2.0_05.jar
%{__rm} -f nbbuild/netbeans/%{nb_platform}/modules/ext/jh-2.0_05.jar
%{__rm} -f nbbuild/netbeans/%{nb_platform}/modules/ext/jna-3.0.2.jar
%{__rm} -f nbbuild/netbeans/%{nb_harness}/jsearch-2.0_05.jar

# clean up stub jars
%{__rm} -f nbbuild/netbeans/%{nb_platform}/modules/ext/script-api.jar

%install

%{__rm} -rf %{buildroot}

# install platform
%{__mkdir_p} %{buildroot}%{nb_platform_dir}
%{__cp} -pr nbbuild/netbeans/%{nb_platform}/* %{buildroot}%{nb_platform_dir}

# linking the platform to the external JARs
%{__ln_s} -f %{_javadir}/swing-layout.jar %{buildroot}%{nb_platform_dir}/modules/ext/swing-layout-1.0.3.jar
%{__ln_s} -f %{_javadir}/javahelp2.jar %{buildroot}%{nb_platform_dir}/modules/ext/jsearch-2.0_05.jar
%{__ln_s} -f %{_javadir}/javahelp2.jar %{buildroot}%{nb_platform_dir}/modules/ext/jh-2.0_05.jar
%{__ln_s} -f %{_javadir}/jna.jar %{buildroot}%{nb_platform_dir}/modules/ext/jna-3.0.2.jar

# install harness
%{__mkdir_p} %{buildroot}%{nb_harness_dir}
%{__cp} -pr nbbuild/netbeans/%{nb_harness}/* %{buildroot}%{nb_harness_dir}

# linking the harness to the external JARs
%{__ln_s} -f %{_javadir}/javahelp2.jar %{buildroot}%{nb_harness_dir}/jsearch-2.0_05.jar

# install javadoc
%{__mkdir_p} %{buildroot}%{nb_javadoc_dir}
%{__cp} -pr nbbuild/build/javadoc/* %{buildroot}%{nb_javadoc_dir}

%clean
%{__rm} -rf %{buildroot}

%post
%noautoupdate %{nb_platform_dir}

%preun
%rm_noautoupdate %{nb_platform_dir}

%post %{nb_harness}
%noautoupdate %{nb_harness_dir}

%preun %{nb_harness}
%rm_noautoupdate %{nb_harness_dir}

%files
%defattr(-,root,root,-)
%doc nbbuild/licenses/CDDL-1.0 nbbuild/licenses/CDDL-GPL-2-CP 
%doc nbbuild/licenses/GPL-2-CP nbbuild/licenses/GPL-with-Proguard-exception
%dir %{nb_platform_dir}/
%{nb_platform_dir}/config
%{nb_platform_dir}/core
%dir %{nb_platform_dir}/lib
%{nb_platform_dir}/lib/boot.jar
%attr(755, root, root) %{nb_platform_dir}/lib/nbexec
%{nb_platform_dir}/lib/org-openide-modules.jar
%{nb_platform_dir}/lib/org-openide-util.jar
%{nb_platform_dir}/modules
%{nb_platform_dir}/update_tracking

%files %{nb_harness}
%defattr(-,root,root,-)
%dir %{nb_harness_dir}/
%{nb_harness_dir}/config
%{nb_harness_dir}/etc
%{nb_harness_dir}/jnlp
%dir %{nb_harness_dir}/launchers
%attr(755, root, root) %{nb_harness_dir}/launchers/app.sh
%{nb_harness_dir}/modules
%{nb_harness_dir}/update_tracking
%doc %{nb_harness_dir}/README
%{nb_harness_dir}/build.xml
%{nb_harness_dir}/common.xml
%{nb_harness_dir}/jdk.xml
%{nb_harness_dir}/jnlp.xml
%{nb_harness_dir}/jsearch-2.0_05.jar
%{nb_harness_dir}/run.xml
%{nb_harness_dir}/suite.xml
%{nb_harness_dir}/tasks.jar

%files %{nb_javadoc}
%defattr(-,root,root,-)
%doc %{nb_javadoc_dir}/

%changelog
* Mon Sep 22 2008 Victor Vasilyev <victor.vasilyev@sun.com> 6.1-5
- Patch3: Issue http://www.netbeans.org/issues/show_bug.cgi?id=143729

* Mon Sep 08 2008 Victor Vasilyev <victor.vasilyev@sun.com> 6.1-4
- Linking to the external JARs is moved to the %%install script from the %%post scripts
- Canonical value for %%defattr is used

* Thu Sep 04 2008 Victor Vasilyev <victor.vasilyev@sun.com> 6.1-3
- The %%{buildroot} is used everywhere instead of $RPM_BUILD_ROOT
- The java, java-devel and jpackage-utils requirenments are used

* Thu Aug 07 2008 Victor Vasilyev <victor.vasilyev@sun.com> 6.1-2
- Suppress rpmlint warnings about hidden .noautoupdate files
- Appropriate values of Group Tags are chosen from the official list
- Avoid dangling symlinks after %%install
* Fri Jun 06 2008 Victor Vasilyev <victor.vasilyev@sun.com> 6.1-1
- Initial version of the platform 8 package
